From d224b952e60805b8da8bc4abf1e15678a79703ce Mon Sep 17 00:00:00 2001
From: Mark Dilger <mark.dilger@enterprisedb.com>
Date: Tue, 3 Aug 2021 09:40:04 -0700
Subject: [PATCH v5 03/12] Adding role pg_manage_vacuum_settings

This new role can SET and ALTER SYSTEM SET any GUC variable which
controls vacuum behavior or resource usage.
---
 doc/src/sgml/user-manag.sgml                  |   11 +-
 src/backend/utils/misc/guc.c                  |   14 +-
 src/include/catalog/pg_authid.dat             |    5 +
 src/include/utils/guc.h                       |    1 +
 .../expected/guc_priv_vacuum_admin.out        | 2489 +++++++++++++++++
 src/test/regress/parallel_schedule            |    2 +-
 .../regress/sql/guc_priv_vacuum_admin.sql     | 1423 ++++++++++
 7 files changed, 3936 insertions(+), 9 deletions(-)
 create mode 100644 src/test/regress/expected/guc_priv_vacuum_admin.out
 create mode 100644 src/test/regress/sql/guc_priv_vacuum_admin.sql

diff --git a/doc/src/sgml/user-manag.sgml b/doc/src/sgml/user-manag.sgml
index 269429d91c..fac3312d6c 100644
--- a/doc/src/sgml/user-manag.sgml
+++ b/doc/src/sgml/user-manag.sgml
@@ -585,6 +585,10 @@ DROP ROLE doomed_role;
        <entry>pg_manage_host_resource_settings</entry>
        <entry>Allow changing settings which control host resource usage.</entry>
       </row>
+      <row>
+       <entry>pg_manage_vacuum_settings</entry>
+       <entry>Allow changing settings which control vacuum behavior.</entry>
+      </row>
      </tbody>
     </tgroup>
    </table>
@@ -629,9 +633,10 @@ DROP ROLE doomed_role;
   </para>
 
   <para>
-  The <literal>pg_manage_host_resource_settings</literal> role is intended to
-  allow administrators to have a trusted, but non-superuser, role to configure
-  memory, cpu, disk and filehandle usage.
+  The <literal>pg_manage_host_resource_settings</literal> and
+  <literal>pg_manage_vacuum_settings</literal> roles are intended to allow
+  administrators to have trusted, but non-superuser, roles to configure the
+  server.
   </para>
 
   <para>
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index fc62d584ae..f7f2893746 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -2608,7 +2608,7 @@ static struct config_int ConfigureNamesInt[] =
 		{"vacuum_cost_page_hit", PGC_USERSET, RESOURCES_VACUUM_DELAY,
 			gettext_noop("Vacuum cost for a page found in the buffer cache."),
 			NULL,
-			GUC_SUPERUSER_ONLY
+			GUC_MANAGE_VACUUM_SETTINGS
 		},
 		&VacuumCostPageHit,
 		1, 0, 10000,
@@ -2619,7 +2619,7 @@ static struct config_int ConfigureNamesInt[] =
 		{"vacuum_cost_page_miss", PGC_USERSET, RESOURCES_VACUUM_DELAY,
 			gettext_noop("Vacuum cost for a page not found in the buffer cache."),
 			NULL,
-			GUC_SUPERUSER_ONLY
+			GUC_MANAGE_VACUUM_SETTINGS
 		},
 		&VacuumCostPageMiss,
 		2, 0, 10000,
@@ -2630,7 +2630,7 @@ static struct config_int ConfigureNamesInt[] =
 		{"vacuum_cost_page_dirty", PGC_USERSET, RESOURCES_VACUUM_DELAY,
 			gettext_noop("Vacuum cost for a page dirtied by vacuum."),
 			NULL,
-			GUC_SUPERUSER_ONLY
+			GUC_MANAGE_VACUUM_SETTINGS
 		},
 		&VacuumCostPageDirty,
 		20, 0, 10000,
@@ -2641,7 +2641,7 @@ static struct config_int ConfigureNamesInt[] =
 		{"vacuum_cost_limit", PGC_USERSET, RESOURCES_VACUUM_DELAY,
 			gettext_noop("Vacuum cost amount available before napping."),
 			NULL,
-			GUC_SUPERUSER_ONLY
+			GUC_MANAGE_VACUUM_SETTINGS
 		},
 		&VacuumCostLimit,
 		200, 1, 10000,
@@ -3986,7 +3986,7 @@ static struct config_real ConfigureNamesReal[] =
 		{"vacuum_cost_delay", PGC_USERSET, RESOURCES_VACUUM_DELAY,
 			gettext_noop("Vacuum cost delay in milliseconds."),
 			NULL,
-			GUC_SUPERUSER_ONLY,
+			GUC_MANAGE_VACUUM_SETTINGS,
 			GUC_UNIT_MS
 		},
 		&VacuumCostDelay,
@@ -7609,6 +7609,10 @@ role_has_privileges(Oid roleid, int privileges)
 		! has_privs_of_role(roleid, ROLE_PG_MANAGE_HOST_RESOURCE_SETTINGS))
 		return false;
 
+	if ((privileges & GUC_MANAGE_VACUUM_SETTINGS) &&
+		! has_privs_of_role(roleid, ROLE_PG_MANAGE_VACUUM_SETTINGS))
+		return false;
+
 	return true;
 }
 
diff --git a/src/include/utils/guc.h b/src/include/utils/guc.h
index b1ffc58b6a..1cae7d2935 100644
--- a/src/include/utils/guc.h
+++ b/src/include/utils/guc.h
@@ -202,6 +202,7 @@ typedef enum
  * privilege bits required to modify a GUC variable
  */
 #define GUC_MANAGE_HOST_RESOURCE_SETTINGS	0x0001
+#define GUC_MANAGE_VACUUM_SETTINGS			0x0002
 
 /*
  * bit values in "flags" of a GUC variable
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 2297f35935..9ad2b077ba 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -86,7 +86,7 @@ test: brin_bloom brin_multi
 # ----------
 # Another group of parallel tests
 # ----------
-test: create_table_like alter_generic alter_operator misc async dbsize misc_functions sysviews tsrf tid tidscan tidrangescan collate.icu.utf8 incremental_sort guc_priv_admin guc_priv_host_resource_admin
+test: create_table_like alter_generic alter_operator misc async dbsize misc_functions sysviews tsrf tid tidscan tidrangescan collate.icu.utf8 incremental_sort guc_priv_admin guc_priv_host_resource_admin guc_priv_vacuum_admin
 
 # rules cannot run concurrently with any test that creates
 # a view or rule in the public schema
